<template>
  <div class="home">
    <b-card no-body>
      <b-row class="p-2 m-0">
        <b-col class="pl-0">
          <b-form-input type="search" v-model="search" placeholder="Search ..."></b-form-input>
        </b-col>
        <b-col class="btn-filter p-0">
          <b-button size="lg" variant="link" class="mr-2" @click="orderBy(tabIndex)">
            <b-icon icon="list-check" aria-label="Filter"></b-icon>
          </b-button>
          <b-button size="lg" variant="link">
            <b-icon icon="alarm" aria-label="Filter"></b-icon>
          </b-button>
        </b-col>
      </b-row>
      <b-tabs card justified v-model="tabIndex">
        <b-tab title="All" active>
          <b-card-text>
            <b-card
              v-for="item in search != '' ? searchLists(launchesAll) : launchesAll"
              :key="item.index"
              :img-src="item.links.patch.small"
              img-alt="Card image"
              img-left
              class="card-launces mb-3 px-2 py-3"
              @click="showModal(item)"
            >
              <b-card-text class="text-left">
                <h6 class="float-left font-weight-bold">{{ item.name }}</h6>
                <span
                  v-if="item.upcoming == true"
                  class="status-upcoming float-right ml-2"
                  >Upcoming</span
                >
                <span class="float-right detail-launches">{{
                  currentDateTime(item.date_utc)
                }}</span>
              </b-card-text>
            </b-card>
          </b-card-text>
        </b-tab>
        <b-tab title="Launched">
          <b-card-text>
            <b-card
              v-for="item in search != ''
                ? searchLists(launches)
                : launches"
              :key="item.index"
              :img-src="item.links.patch.small"
              img-alt="Card image"
              img-left
              class="card-launces mb-3 px-2 py-3"
              @click="showModal(item)"
            >
              <b-card-text class="text-left">
                <h6 class="float-left font-weight-bold">{{ item.name }}</h6>
                <span
                  v-if="item.upcoming == true"
                  class="status-upcoming float-right ml-2"
                  >Upcoming</span
                >
                <span class="float-right detail-launches">{{
                  currentDateTime(item.date_utc)
                }}</span>
              </b-card-text>
            </b-card>
          </b-card-text>
        </b-tab>
        <b-tab title="Upcoming">
          <b-card-text>
            <b-card
              v-for="item in search != ''
                ? searchLists(upComing)
                : upComing"
              :key="item.index"
              :img-src="item.links.patch.small"
              img-alt="Card image"
              img-left
              class="card-launces mb-3 px-2 py-3"
              @click="showModal(item)"
            >
              <b-card-text class="text-left">
                <h6 class="float-left font-weight-bold">{{ item.name }}</h6>
                <span
                  v-if="item.upcoming == true"
                  class="status-upcoming float-right ml-2"
                  >Upcoming</span
                >
                <span class="float-right detail-launches">{{
                  currentDateTime(item.date_utc)
                }}</span>
              </b-card-text>
            </b-card>
          </b-card-text>
        </b-tab>
      </b-tabs>
    </b-card>
    <Modal :items="dataModal"/>
  </div>
</template>

<script>
// @ is an alias to /src
import HelloWorld from "@/components/HelloWorld.vue";
import moment from "moment";
import Modal from "@/components/Modal.vue";
import { mapActions } from "vuex";

export default {
  name: "Home",
  data() {
    return {
      search: "",
      sorting: false,
      tabIndex: 0,
      launchesAll: null,
      launches: null,
      upComing: null,
      dataModal: {}
    };
  },
  components: {
    HelloWorld,
    Modal,
  },
  mounted() {
    this.getAll();
    
  },
  methods: {
    ...mapActions(["doShowModal"]),
    searchLists(items) {
      return items.filter((item) => {
        return item.name.toLowerCase().includes(this.search.toLowerCase());
      });
    },
    orderBy(tabIndex) {
      this.sorting = !this.sorting;
      if(this.sorting) {
        if(tabIndex === 0) {
          return this.launchesAll.sort((a,b) => (a.name > b.name) ? 1 : -1);
        }
        else if(tabIndex === 1) {
          return this.launches.sort((a,b) => (a.name > b.name) ? 1 : -1);
        }
        return this.upComing.sort((a,b) => (a.name > b.name) ? 1 : -1);
        
      }
      else {
        if(tabIndex === 0) {
          return this.launchesAll.sort((a,b) => (a.name < b.name) ? 1 : -1);
        }
        else if(tabIndex === 1) {
          return this.launches.sort((a,b) => (a.name < b.name) ? 1 : -1);
        }
        return this.upComing.sort((a,b) => (a.name < b.name) ? 1 : -1);
      }
    },
    currentDateTime(staticFireDate) {
      return moment(staticFireDate).format("ddd MMM DD YYYY");
    },
    async getAll() {
      await this.axios
        .get("https://api.spacexdata.com/v4/launches")
        .then((response) => {
          this.launchesAll = response.data;
          this.launches = this.launchesAll.filter(
            (item) => item.success === true
          );
          this.upComing = this.launchesAll.filter(
            (item) => item.upcoming === true
          );
          console.log("All:---->", this.launchesAll);
          console.log("Launches:---->", this.launches);
          console.log("Upcoming:---->", this.upComing);
        });
    },
    showModal(item) {
      this.dataModal = item;
      console.log("Modal:--->", this.dataModal);
      this.$store.dispatch("doShowModal", { showModal: true });
    },
  },
};
</script>

<style lang="scss">
.tab-pane.card-body {
  background-color: rgba(0, 0, 0, 0.03);
}
.btn-filter {
  width: 90px !important;
  max-width: 90px !important;
  height: 40px !important;
  padding: 0 !important;
   button {
    width: 40px !important;
    max-width: 40px !important;
    height: 40px !important;
    padding: 0 !important;
  }
}
.card-launces {
  font-size: 0.765rem !important;
  .card-img-left {
    width: 80px;
    height: 80px;
    border-radius: 50% !important;
  }
  .status-upcoming {
    color: blue;
    font-size: 12px;
    font-weight: bold;
  }
}
</style>